@echo off
SetLocal EnableExtensions EnableDelayedExpansion

:Main
pushd "%~dp0" && call :MakeColorDB
popd
exit /b %ErrorLevel%
goto :EOF

:MakeColorDB
if exist ColorDB.tab goto :MakeTxt
if exist ColorDB.tab del /f ColorDB.tab
unix touch ColorDB.tab
for /f "usebackq tokens=* delims=" %%i in (`dir /b /s .\ ^| unix grep -i -e '\\ColorDB\\' ^| unix u2d`) do (
 type %%i | unix d2u | unix grep -e '\^"' | unix sort | unix uniq | unix u2d >> ColorDB.tab
)
type ColorDB.tab
:MakeTxt
if exist ColorDB.txt del /f ColorDB.txt
for %%m in (1 2) do (
 set iter=%%m
 if exist ColorDB.tmp del /f ColorDB.tmp & unix touch ColorDB.tmp
 call :ProcessColorTab ColorDB.tab >> ColorDB.tmp
 type ColorDB.tmp | unix d2u | unix sort | unix uniq | unix u2d >> ColorDB.txt
 if exist ColorDB.tmp del /f ColorDB.tmp
)
type ColorDB.txt
goto :EOF

:ProcessColorTab
if "%~1" == "" goto :EOF
for /f "usebackq tokens=* delims=" %%i in (`type %~1 ^| unix replacestr "{" " " ^| unix replacestr "}" " " ^| unix replacestr "," " "`) do call :ProcessLine %%i
goto :EOF

:ProcessLine
if "%~1" == "" goto :EOF
if "%~1" == "" goto :EOF
set "Name=%~1"
set "Value=%~2"
if "%Value%" == "N" (
 set "B=%~3"
 set "G=%~4"
 set "R=%~5"
 if "%iter%" == "2" (
  if defined R (
   unix printf '%%-40s = $%%2.2X%%2.2X%%2.2X;\r\n' '!Name!' '!R!' '!G!' '!B!'
  ) else (
   unix printf '%%-40s = %%s;\r\n' '!Name!' '!B!'
  )
 )
) else (
 if "%iter%" == "1" (
  unix printf '%%-40s = %%s;\r\n' '!Name!' '!Value!'
 )
)
goto :EOF
