class: TOP_highvoltage_CLASS
!panel: highvoltage.pnl
    state: OFF	!color: FwStateOKNotPhysics
        when ( any_in FWCHILDREN_FWSETSTATES in_state ERROR )  move_to ERROR

        when ( all_in FWISEGCRATE_FWSETSTATES in_state ON ) move_to NOT_READY
        action: SWITCH_ON	!visible: 1
            do SWITCH_ON all_in FWISEGCRATE_FWSETACTIONS
            do SET_RAMP_SPEED all_in FWISEGMODULE_FWSETACTIONS
            if ( all_in FWISEGCRATE_FWSETSTATES not_in_state ON )  then
               move_to OFF
            endif
            move_to NOT_READY
    state: NOT_READY	!color: FwStateOKNotPhysics
        when ( any_in FWCHILDREN_FWSETSTATES in_state ERROR )  move_to ERROR

        when ( all_in FWISEGCRATE_FWSETSTATES in_state OFF )  move_to OFF

        when (  ( all_in FWISEGCRATE_FWSETSTATES in_state ON ) and
(  ( any_in FWISEGCHANNEL_FWSETSTATES in_state RAMPING_UP ) or
( any_in FWISEGCHANNEL_FWSETSTATES in_state RAMPING_DOWN ) or 
( all_in FWISEGCHANNEL_FWSETSTATES in_state ON )  )  ) move_to CONFIGURING
        action: SWITCH_OFF	!visible: 1
            do SWITCH_OFF all_in FWISEGCHANNEL_FWSETACTIONS
        !action: ----------
        action: GO_READY	!visible: 1
            do SET_RAMP_SPEED all_in FWISEGMODULE_FWSETACTIONS
            do SWITCH_ON all_in FWISEGCHANNEL_FWSETACTIONS
            if ( any_in FWISEGCHANNEL_FWSETSTATES not_in_state RAMPING_UP )  then
                move_to NOT_READY
            endif
            move_to CONFIGURING
        action: RESET_EMERG	!visible: 0
            do RESET_EMERG all_in FWISEGMODULE_FWSETACTIONS
            do RESET_EMERG all_in FWISEGCHANNEL_FWSETACTIONS
        action: SET_RAMP_SPEED	!visible: 0
            do SET_RAMP_SPEED all_in FWISEGMODULE_FWSETACTIONS
    state: CONFIGURING	!color: FwStateAttention1
        when ( any_in FWCHILDREN_FWSETSTATES in_state ERROR )  move_to ERROR

        when (  ( any_in FWISEGCRATE_FWSETSTATES in_state OFF ) or
(  ( any_in FWISEGCHANNEL_FWSETSTATES in_state OFF ) and  
( all_in FWISEGCHANNEL_FWSETSTATES not_in_state RAMPING_UP ) and
( all_in FWISEGCHANNEL_FWSETSTATES not_in_state RAMPING_DOWN )  )  ) move_to NOT_READY
        when (  ( all_in FWISEGCRATE_FWSETSTATES in_state ON ) and
( all_in FWISEGCHANNEL_FWSETSTATES in_state ON )  )  move_to READY
        action: STOP	!visible: 1
            do SET_RAMP_SPEED_DOWN all_in FWISEGMODULE_FWSETACTIONS
            do STOP all_in FWISEGCHANNEL_FWSETACTIONS
        action: RESET_EMERG	!visible: 1
            do RESET_EMERG all_in FWISEGMODULE_FWSETACTIONS
            do RESET_EMERG all_in FWISEGCHANNEL_FWSETACTIONS
    state: READY	!color: FwStateOKPhysics
        when ( any_in FWCHILDREN_FWSETSTATES in_state ERROR )  move_to ERROR

        when (  ( any_in FWISEGCRATE_FWSETSTATES in_state OFF )  or 
( any_in FWISEGCHANNEL_FWSETSTATES in_state RAMPING_DOWN ) or
( any_in FWISEGCHANNEL_FWSETSTATES in_state RAMPING_UP ) or
( any_in FWISEGCHANNEL_FWSETSTATES in_state OFF )  ) move_to CONFIGURING
        action: GO_OFF	!visible: 1
            do SET_RAMP_SPEED_DOWN all_in FWISEGMODULE_FWSETACTIONS
            do SWITCH_OFF all_in FWISEGCHANNEL_FWSETACTIONS
            if ( all_in FWISEGCHANNEL_FWSETSTATES in_state ON )  then
                move_to READY
            endif
            move_to CONFIGURING
        action: RESET_EMERG	!visible: 0
            do RESET_EMERG all_in FWISEGMODULE_FWSETACTIONS
            do RESET_EMERG all_in FWISEGCHANNEL_FWSETACTIONS
    state: ERROR	!color: FwStateAttention3
        when ( all_in FWCHILDREN_FWSETSTATES not_in_state ERROR )  move_to NOT_READY
        action: RESET	!visible: 1
            do RESET all_in FWCHILDREN_FWSETACTIONS
            if ( any_in FWCHILDREN_FWSETSTATES in_state ERROR )  then
                move_to ERROR
            endif
        action: RESET_EMERG	!visible: 1
            do RESET_EMERG all_in FWISEGMODULE_FWSETACTIONS
            do RESET all_in FWISEGCHANNEL_FWSETACTIONS
            do SWITCH_OFF all_in FWISEGCHANNEL_FWSETACTIONS

object: phs_mod4_hv is_of_class TOP_highvoltage_CLASS

class: FwChildrenMode_CLASS
!panel: FwChildrenMode.pnl
    state: Complete	!color: _3DFace
        when ( any_in FWDEVMODE_FWSETSTATES in_state DISABLED )  move_to IncompleteDev
    state: Incomplete	!color: FwStateAttention2
    state: IncompleteDev	!color: FwStateAttention1
        when (  ( all_in FWDEVMODE_FWSETSTATES not_in_state DISABLED )  ) move_to Complete
    state: IncompleteDead	!color: FwStateAttention3

object: phs_mod4_hv_FWCNM is_of_class FwChildrenMode_CLASS

class: FwMode_CLASS
!panel: FwMode.pnl
    state: Excluded	!color: FwStateOKNotPhysics
        action: Take(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 1
            move_to InLocal
        action: Include(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
            move_to Included
        action: Manual	!visible: 0
            move_to Manual
        action: Ignore	!visible: 0
            move_to Ignored
    state: Included	!color: FwStateOKPhysics
        action: Exclude(string OWNER = "")	!visible: 0
            move_to Excluded
        action: Manual(string OWNER = "")	!visible: 0
            move_to Manual
        action: Ignore(string OWNER = "")	!visible: 0
            move_to Ignored
        action: ExcludeAll(string OWNER = "")	!visible: 0
            move_to Excluded
        action: Include(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
            move_to Included
        action: Free(string OWNER = "")	!visible: 0
            move_to Included
        action: SetMode(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
    state: InLocal	!color: FwStateOKNotPhysics
        action: Release(string OWNER = "")	!visible: 1
            move_to Excluded
        action: ReleaseAll(string OWNER = "")	!visible: 1
            move_to Excluded
        action: SetMode(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
        action: Take(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 1
            move_to InLocal
    state: Manual	!color: FwStateOKNotPhysics
        action: Include(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
            move_to Included
        action: Take(string OWNER = "")	!visible: 1
            move_to InManual
        action: Exclude(string OWNER = "")	!visible: 0
            move_to Excluded
        action: Ignore	!visible: 0
            move_to Ignored
        action: Free(string OWNER = "")	!visible: 0
            move_to Excluded
        action: ExcludeAll(string OWNER = "")	!visible: 0
            move_to Excluded
    state: InManual	!color: FwStateOKNotPhysics
        action: Release(string OWNER = "")	!visible: 1
            move_to Manual
        action: SetMode(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
        action: ReleaseAll(string OWNER = "")	!visible: 0
            move_to Excluded
        action: SetInLocal	!visible: 0
            move_to InLocal
    state: Ignored	!color: FwStateOKNotPhysics
        action: Include	!visible: 0
            move_to Included
        action: Exclude(string OWNER = "")	!visible: 0
            move_to Excluded
        action: Manual	!visible: 0
            move_to Manual
        action: SetMode(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
        action: Free(string OWNER = "")	!visible: 0
            move_to Included
        action: ExcludeAll(string OWNER = "")	!visible: 0
            move_to Excluded

object: phs_mod4_hv_FWM is_of_class FwMode_CLASS

class: FwIsegModule_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from FWISEGMODULE_FWSETSTATES
            remove &VAL_OF_Device from FWISEGMODULE_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in FWISEGMODULE_FWSETSTATES
            insert &VAL_OF_Device in FWISEGMODULE_FWSETACTIONS
            move_to READY

object: FwIsegModule_FWDM is_of_class FwIsegModule_FwDevMode_CLASS


class: FwIsegModule_CLASS/associated
!panel: FwIsegModule.pnl
    state: ON	!color: FwStateOKPhysics
        action: RESET_EMERG	!visible: 0
        action: SET_RAMP_SPEED	!visible: 0
        action: SET_RAMP_SPEED_DOWN	!visible: 0
    state: OFF	!color: FwStateOKNotPhysics
        action: RESET_EMERG	!visible: 0
        action: SET_RAMP_SPEED	!visible: 0
        action: SET_RAMP_SPEED_DOWN	!visible: 0
    state: ERROR	!color: FwStateAttention3
        action: RESET	!visible: 0
        action: RESET_EMERG	!visible: 0

object: Iseg:can0:crate00:ma04 is_of_class FwIsegModule_CLASS

objectset: FWISEGMODULE_FWSETSTATES is_of_class VOID {Iseg:can0:crate00:ma04 }
objectset: FWISEGMODULE_FWSETACTIONS is_of_class VOID {Iseg:can0:crate00:ma04 }

class: FwIsegChannel_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from FWISEGCHANNEL_FWSETSTATES
            remove &VAL_OF_Device from FWISEGCHANNEL_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in FWISEGCHANNEL_FWSETSTATES
            insert &VAL_OF_Device in FWISEGCHANNEL_FWSETACTIONS
            move_to READY

object: FwIsegChannel_FWDM is_of_class FwIsegChannel_FwDevMode_CLASS


class: FwIsegChannel_CLASS/associated
!panel: FwIsegChannel.pnl
    state: ON	!color: FwStateOKPhysics
        action: SWITCH_OFF	!visible: 1
        action: RESET_EMERG	!visible: 0
    state: RAMPING_UP	!color: FwStateAttention1
        action: STOP	!visible: 1
        action: RESET_EMERG	!visible: 0
    state: RAMPING_DOWN	!color: FwStateAttention1
        action: RESET_EMERG	!visible: 0
    state: OFF	!color: FwStateOKNotPhysics
        action: SWITCH_ON	!visible: 1
    state: ERROR	!color: FwStateAttention3
        action: RESET	!visible: 1
        action: RESET_EMERG	!visible: 0

object: Iseg:can0:crate00:ma04:ch00 is_of_class FwIsegChannel_CLASS

object: Iseg:can0:crate00:ma04:ch01 is_of_class FwIsegChannel_CLASS

object: Iseg:can0:crate00:ma04:ch02 is_of_class FwIsegChannel_CLASS

object: Iseg:can0:crate00:ma04:ch03 is_of_class FwIsegChannel_CLASS

object: Iseg:can0:crate00:ma04:ch04 is_of_class FwIsegChannel_CLASS

object: Iseg:can0:crate00:ma04:ch05 is_of_class FwIsegChannel_CLASS

object: Iseg:can0:crate00:ma04:ch06 is_of_class FwIsegChannel_CLASS

object: Iseg:can0:crate00:ma04:ch07 is_of_class FwIsegChannel_CLASS

objectset: FWISEGCHANNEL_FWSETSTATES is_of_class VOID {Iseg:can0:crate00:ma04:ch00,
	Iseg:can0:crate00:ma04:ch01,
	Iseg:can0:crate00:ma04:ch02,
	Iseg:can0:crate00:ma04:ch03,
	Iseg:can0:crate00:ma04:ch04,
	Iseg:can0:crate00:ma04:ch05,
	Iseg:can0:crate00:ma04:ch06,
	Iseg:can0:crate00:ma04:ch07 }
objectset: FWISEGCHANNEL_FWSETACTIONS is_of_class VOID {Iseg:can0:crate00:ma04:ch00,
	Iseg:can0:crate00:ma04:ch01,
	Iseg:can0:crate00:ma04:ch02,
	Iseg:can0:crate00:ma04:ch03,
	Iseg:can0:crate00:ma04:ch04,
	Iseg:can0:crate00:ma04:ch05,
	Iseg:can0:crate00:ma04:ch06,
	Iseg:can0:crate00:ma04:ch07 }

class: FwIsegCrate_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from FWISEGCRATE_FWSETSTATES
            remove &VAL_OF_Device from FWISEGCRATE_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in FWISEGCRATE_FWSETSTATES
            insert &VAL_OF_Device in FWISEGCRATE_FWSETACTIONS
            move_to READY

object: FwIsegCrate_FWDM is_of_class FwIsegCrate_FwDevMode_CLASS


class: FwIsegCrate_CLASS/associated
!panel: FwIsegCrate.pnl
    state: ON	!color: FwStateOKPhysics
        action: SWITCH_OFF	!visible: 1
    state: OFF	!color: FwStateOKNotPhysics
        action: SWITCH_ON	!visible: 1
    state: ERROR	!color: FwStateAttention3
        action: RESET	!visible: 1

object: phs_logical:iseg:crate00 is_of_class FwIsegCrate_CLASS

objectset: FWISEGCRATE_FWSETSTATES is_of_class VOID {phs_logical:iseg:crate00 }
objectset: FWISEGCRATE_FWSETACTIONS is_of_class VOID {phs_logical:iseg:crate00 }

class: FwDevMode_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from FWDEVMODE_FWSETSTATES
            remove &VAL_OF_Device from FWDEVMODE_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in FWDEVMODE_FWSETSTATES
            insert &VAL_OF_Device in FWDEVMODE_FWSETACTIONS
            move_to READY

object: FwDevMode_FWDM is_of_class FwDevMode_FwDevMode_CLASS


class: FwDevMode_CLASS/associated
!panel: FwDevMode.pnl
    state: ENABLED	!color: FwStateOKPhysics
    state: DISABLED	!color: FwStateAttention1

object: phs_mod4_hv_FWDM is_of_class FwDevMode_CLASS

objectset: FWDEVMODE_FWSETSTATES is_of_class VOID {phs_mod4_hv_FWDM }
objectset: FWDEVMODE_FWSETACTIONS is_of_class VOID {phs_mod4_hv_FWDM }


objectset: FWCHILDREN_FWSETACTIONS union {FWISEGMODULE_FWSETACTIONS,
	FWISEGCHANNEL_FWSETACTIONS,
	FWISEGCRATE_FWSETACTIONS } is_of_class VOID
objectset: FWCHILDREN_FWSETSTATES union {FWISEGMODULE_FWSETSTATES,
	FWISEGCHANNEL_FWSETSTATES,
	FWISEGCRATE_FWSETSTATES } is_of_class VOID

