class: PMD_VMETOP_VME_CLASS
!panel: VME.pnl
    state: READY	!color: FwStateOKPhysics
        when (  ( all_in PMD_VMEFWWIENERCANBUS_FWSETSTATES in_state CONTROL_OK ) and
       ( any_in PMD_VMEFWWIENERCRATE_FWSETSTATES in_state OFF )  )  move_to NOT_READY
        when ( any_in PMD_VMEFWWIENERCRATE_FWSETSTATES in_state PWS_FAILURE )  move_to ERROR
        when (  ( any_in PMD_VMEFWWIENERCANBUS_FWSETSTATES in_state NO_CONTROL ) or
       ( any_in PMD_VMEFWWIENERCRATE_FWSETSTATES in_state NO_CONTROL )  )  move_to NO_CONTROL
        action: SWITCH_OFF_ALL	!visible: 2
            do SWITCH_OFF all_in PMD_VMEFWWIENERCRATE_FWSETACTIONS
    state: NOT_READY	!color: FwStateOKNotPhysics
        when (  ( all_in PMD_VMEFWWIENERCRATE_FWSETSTATES in_state ON ) and
       ( all_in PMD_VMEFWWIENERCANBUS_FWSETSTATES in_state CONTROL_OK )  )  move_to READY
        when ( any_in PMD_VMEFWWIENERCRATE_FWSETSTATES in_state PWS_FAILURE )  move_to ERROR
        when (  ( any_in PMD_VMEFWWIENERCANBUS_FWSETSTATES in_state NO_CONTROL ) or
       ( any_in PMD_VMEFWWIENERCRATE_FWSETSTATES in_state NO_CONTROL )  )  move_to NO_CONTROL
        action: SWITCH_ON_ALL	!visible: 2
            do SWITCH_ON all_in PMD_VMEFWWIENERCRATE_FWSETACTIONS
    state: ERROR	!color: FwStateAttention3
        when (  ( all_in PMD_VMEFWWIENERCRATE_FWSETSTATES in_state ON ) and
       ( all_in PMD_VMEFWWIENERCANBUS_FWSETSTATES in_state CONTROL_OK )  )  move_to READY
        when ( all_in PMD_VMEFWWIENERCRATE_FWSETSTATES not_in_state PWS_FAILURE )  move_to NOT_READY
        when ( any_in PMD_VMEFWCHILDREN_FWSETSTATES in_state NO_CONTROL )  move_to NO_CONTROL
        action: RESET_VME_bus	!visible: 2
            do RESET_VME_Bus all_in PMD_VMEFWWIENERCRATE_FWSETACTIONS
        action: SWITCH_ON_ALL	!visible: 2
            do SWITCH_ON all_in PMD_VMEFWWIENERCRATE_FWSETACTIONS
    state: NO_CONTROL	!color: FwStateAttention2
        when (  ( all_in PMD_VMEFWWIENERCANBUS_FWSETSTATES in_state CONTROL_OK ) and
       ( all_in PMD_VMEFWWIENERCRATE_FWSETSTATES in_state ON )  )  move_to READY
        when (  ( all_in PMD_VMEFWWIENERCANBUS_FWSETSTATES in_state CONTROL_OK ) and
       ( any_in PMD_VMEFWWIENERCRATE_FWSETSTATES in_state OFF )  )  move_to NOT_READY
        when (  ( any_in PMD_VMEFWWIENERCRATE_FWSETSTATES in_state PWS_FAILURE ) and
       ( all_in PMD_VMEFWCHILDREN_FWSETSTATES not_in_state NO_CONTROL )  )  move_to ERROR

object: PMD_VME is_of_class PMD_VMETOP_VME_CLASS

class: PMD_VMEFwWienerCanBus_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_VMEFWWIENERCANBUS_FWSETSTATES
            remove &VAL_OF_Device from PMD_VMEFWWIENERCANBUS_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_VMEFWWIENERCANBUS_FWSETSTATES
            insert &VAL_OF_Device in PMD_VMEFWWIENERCANBUS_FWSETACTIONS
            move_to READY

object: PMD_VMEFwWienerCanBus_FWDM is_of_class PMD_VMEFwWienerCanBus_FwDevMode_CLASS


class: PMD_VMEFwWienerCanBus_CLASS/associated
!panel: FwWienerCanBus.pnl
    state: CONTROL_OK	!color: FwStateOKPhysics
    state: NO_CONTROL	!color: FwStateAttention2
        action: RESET	!visible: 1

object: Wiener:CAN8 is_of_class PMD_VMEFwWienerCanBus_CLASS

objectset: PMD_VMEFWWIENERCANBUS_FWSETSTATES {Wiener:CAN8 }
objectset: PMD_VMEFWWIENERCANBUS_FWSETACTIONS {Wiener:CAN8 }

class: PMD_VMEFwWienerCrate_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_VMEFWWIENERCRATE_FWSETSTATES
            remove &VAL_OF_Device from PMD_VMEFWWIENERCRATE_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_VMEFWWIENERCRATE_FWSETSTATES
            insert &VAL_OF_Device in PMD_VMEFWWIENERCRATE_FWSETACTIONS
            move_to READY

object: PMD_VMEFwWienerCrate_FWDM is_of_class PMD_VMEFwWienerCrate_FwDevMode_CLASS


class: PMD_VMEFwWienerCrate_CLASS/associated
!panel: FwWienerCrate.pnl
    state: ON	!color: FwStateOKPhysics
        action: SWITCH_OFF	!visible: 2
    state: OFF	!color: FwStateOKNotPhysics
        action: SWITCH_ON	!visible: 2
    state: PWS_FAILURE	!color: FwStateAttention3
        action: SWITCH_ON	!visible: 2
        action: RESET_VME_Bus	!visible: 2
    state: NO_STATE	!color: FwStateAttention1

object: Wiener:CAN8:Crate1 is_of_class PMD_VMEFwWienerCrate_CLASS

objectset: PMD_VMEFWWIENERCRATE_FWSETSTATES {Wiener:CAN8:Crate1 }
objectset: PMD_VMEFWWIENERCRATE_FWSETACTIONS {Wiener:CAN8:Crate1 }


objectset: PMD_VMEFWCHILDREN_FWSETACTIONS union {PMD_VMEFWWIENERCANBUS_FWSETACTIONS,
	PMD_VMEFWWIENERCRATE_FWSETACTIONS }
objectset: PMD_VMEFWCHILDREN_FWSETSTATES union {PMD_VMEFWWIENERCANBUS_FWSETSTATES,
	PMD_VMEFWWIENERCRATE_FWSETSTATES }

class: PMD_DCS_GAS_PMD_DITOP_dcs_gas_subsys_OT_CLASS
!panel: aliGasSys/aliGas_detectorGasElements_visualize.pnl
    state: NOT_READY	!color: FwStateOKNotPhysics
        when ( any_in PMD_DCS_GAS_PMD_DIFWCHILDREN_FWSETSTATES in_state ERROR ) move_to ERROR
        when ( all_in PMD_DCS_GAS_PMD_DIFWCHILDREN_FWSETSTATES in_state READY ) move_to READY
    state: READY	!color: FwStateOKPhysics
        when ( any_in PMD_DCS_GAS_PMD_DIFWCHILDREN_FWSETSTATES in_state ERROR ) move_to ERROR
        when ( any_in PMD_DCS_GAS_PMD_DIFWCHILDREN_FWSETSTATES in_state NOT_READY ) move_to NOT_READY
    state: ERROR	!color: FwStateAttention3
        when ( all_in PMD_DCS_GAS_PMD_DIFWCHILDREN_FWSETSTATES not_in_state ERROR ) move_to NOT_READY
    state: NO_CONNECTION	!color: FwStateAttention2
        when ( all_in PMD_DCS_GAS_PMD_DIFWCHILDREN_FWSETSTATES in_state READY )  move_to READY
        when ( any_in PMD_DCS_GAS_PMD_DIFWCHILDREN_FWSETSTATES not_in_state READY )  move_to NOT_READY

object: PMD_DCS_GAS_PMD_DI is_of_class PMD_DCS_GAS_PMD_DITOP_dcs_gas_subsys_OT_CLASS

class: PMD_DCS_GAS_PMD_DIAliGas_Di_ModStepWS_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_DCS_GAS_PMD_DIALIGAS_DI_MODSTEPWS_FWSETSTATES
            remove &VAL_OF_Device from PMD_DCS_GAS_PMD_DIALIGAS_DI_MODSTEPWS_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_DCS_GAS_PMD_DIALIGAS_DI_MODSTEPWS_FWSETSTATES
            insert &VAL_OF_Device in PMD_DCS_GAS_PMD_DIALIGAS_DI_MODSTEPWS_FWSETACTIONS
            move_to READY

object: PMD_DCS_GAS_PMD_DIAliGas_Di_ModStepWS_FWDM is_of_class PMD_DCS_GAS_PMD_DIAliGas_Di_ModStepWS_FwDevMode_CLASS


class: PMD_DCS_GAS_PMD_DIAliGas_Di_ModStepWS_CLASS/associated
!panel: aliGasSys/AliGas_device_state.pnl
    state: READY	!color: FwStateOKPhysics
    state: NOT_READY	!color: FwStateOKNotPhysics
    state: ERROR	!color: FwStateAttention3

object: Gas_Di_ModStepWS:PMD_Di_ModStepWS is_of_class PMD_DCS_GAS_PMD_DIAliGas_Di_ModStepWS_CLASS

objectset: PMD_DCS_GAS_PMD_DIALIGAS_DI_MODSTEPWS_FWSETSTATES {Gas_Di_ModStepWS:PMD_Di_ModStepWS }
objectset: PMD_DCS_GAS_PMD_DIALIGAS_DI_MODSTEPWS_FWSETACTIONS {Gas_Di_ModStepWS:PMD_Di_ModStepWS }

class: PMD_DCS_GAS_PMD_DIAliGas_Di_RackiStepWS_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_DCS_GAS_PMD_DIALIGAS_DI_RACKISTEPWS_FWSETSTATES
            remove &VAL_OF_Device from PMD_DCS_GAS_PMD_DIALIGAS_DI_RACKISTEPWS_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_DCS_GAS_PMD_DIALIGAS_DI_RACKISTEPWS_FWSETSTATES
            insert &VAL_OF_Device in PMD_DCS_GAS_PMD_DIALIGAS_DI_RACKISTEPWS_FWSETACTIONS
            move_to READY

object: PMD_DCS_GAS_PMD_DIAliGas_Di_RackiStepWS_FWDM is_of_class PMD_DCS_GAS_PMD_DIAliGas_Di_RackiStepWS_FwDevMode_CLASS


class: PMD_DCS_GAS_PMD_DIAliGas_Di_RackiStepWS_CLASS/associated
!panel: aliGasSys/AliGas_device_state.pnl
    state: READY	!color: FwStateOKPhysics
    state: NOT_READY	!color: FwStateOKNotPhysics
    state: ERROR	!color: FwStateAttention3

object: Gas_Di_RackiStepWS:PMD_Di_Rack61StepWS is_of_class PMD_DCS_GAS_PMD_DIAliGas_Di_RackiStepWS_CLASS

objectset: PMD_DCS_GAS_PMD_DIALIGAS_DI_RACKISTEPWS_FWSETSTATES {Gas_Di_RackiStepWS:PMD_Di_Rack61StepWS }
objectset: PMD_DCS_GAS_PMD_DIALIGAS_DI_RACKISTEPWS_FWSETACTIONS {Gas_Di_RackiStepWS:PMD_Di_Rack61StepWS }


objectset: PMD_DCS_GAS_PMD_DIFWCHILDREN_FWSETACTIONS union {PMD_DCS_GAS_PMD_DIALIGAS_DI_MODSTEPWS_FWSETACTIONS,
	PMD_DCS_GAS_PMD_DIALIGAS_DI_RACKISTEPWS_FWSETACTIONS }
objectset: PMD_DCS_GAS_PMD_DIFWCHILDREN_FWSETSTATES union {PMD_DCS_GAS_PMD_DIALIGAS_DI_MODSTEPWS_FWSETSTATES,
	PMD_DCS_GAS_PMD_DIALIGAS_DI_RACKISTEPWS_FWSETSTATES }

class: PMD_DCS_GAS_PMD_GSTOP_dcs_gas_subsys_OT_CLASS
!panel: aliGasSys/aliGas_detectorGasElements_visualize.pnl
    state: NOT_READY	!color: FwStateOKNotPhysics
        when ( any_in PMD_DCS_GAS_PMD_GSFWCHILDREN_FWSETSTATES in_state ERROR ) move_to ERROR
        when ( all_in PMD_DCS_GAS_PMD_GSFWCHILDREN_FWSETSTATES in_state READY ) move_to READY
    state: READY	!color: FwStateOKPhysics
        when ( any_in PMD_DCS_GAS_PMD_GSFWCHILDREN_FWSETSTATES in_state ERROR ) move_to ERROR
        when ( any_in PMD_DCS_GAS_PMD_GSFWCHILDREN_FWSETSTATES in_state NOT_READY ) move_to NOT_READY
    state: ERROR	!color: FwStateAttention3
        when ( all_in PMD_DCS_GAS_PMD_GSFWCHILDREN_FWSETSTATES not_in_state ERROR ) move_to NOT_READY
    state: NO_CONNECTION	!color: FwStateAttention2
        when ( all_in PMD_DCS_GAS_PMD_GSFWCHILDREN_FWSETSTATES in_state READY )  move_to READY
        when ( any_in PMD_DCS_GAS_PMD_GSFWCHILDREN_FWSETSTATES not_in_state READY )  move_to NOT_READY

object: PMD_DCS_GAS_PMD_GS is_of_class PMD_DCS_GAS_PMD_GSTOP_dcs_gas_subsys_OT_CLASS

class: PMD_DCS_GAS_PMD_GSAliGas_Gs_GsStepWS_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_DCS_GAS_PMD_GSALIGAS_GS_GSSTEPWS_FWSETSTATES
            remove &VAL_OF_Device from PMD_DCS_GAS_PMD_GSALIGAS_GS_GSSTEPWS_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_DCS_GAS_PMD_GSALIGAS_GS_GSSTEPWS_FWSETSTATES
            insert &VAL_OF_Device in PMD_DCS_GAS_PMD_GSALIGAS_GS_GSSTEPWS_FWSETACTIONS
            move_to READY

object: PMD_DCS_GAS_PMD_GSAliGas_Gs_GsStepWS_FWDM is_of_class PMD_DCS_GAS_PMD_GSAliGas_Gs_GsStepWS_FwDevMode_CLASS


class: PMD_DCS_GAS_PMD_GSAliGas_Gs_GsStepWS_CLASS/associated
!panel: aliGasSys/AliGas_device_state.pnl
    state: READY	!color: FwStateOKPhysics
    state: NOT_READY	!color: FwStateOKNotPhysics
    state: ERROR	!color: FwStateAttention3

object: Gas_Gs_GsStepWS:PMD_Gs_GsStepWS is_of_class PMD_DCS_GAS_PMD_GSAliGas_Gs_GsStepWS_CLASS

objectset: PMD_DCS_GAS_PMD_GSALIGAS_GS_GSSTEPWS_FWSETSTATES {Gas_Gs_GsStepWS:PMD_Gs_GsStepWS }
objectset: PMD_DCS_GAS_PMD_GSALIGAS_GS_GSSTEPWS_FWSETACTIONS {Gas_Gs_GsStepWS:PMD_Gs_GsStepWS }

class: PMD_DCS_GAS_PMD_GSAliGas_Gs_GSY0505_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_DCS_GAS_PMD_GSALIGAS_GS_GSY0505_FWSETSTATES
            remove &VAL_OF_Device from PMD_DCS_GAS_PMD_GSALIGAS_GS_GSY0505_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_DCS_GAS_PMD_GSALIGAS_GS_GSY0505_FWSETSTATES
            insert &VAL_OF_Device in PMD_DCS_GAS_PMD_GSALIGAS_GS_GSY0505_FWSETACTIONS
            move_to READY

object: PMD_DCS_GAS_PMD_GSAliGas_Gs_GSY0505_FWDM is_of_class PMD_DCS_GAS_PMD_GSAliGas_Gs_GSY0505_FwDevMode_CLASS


class: PMD_DCS_GAS_PMD_GSAliGas_Gs_GSY0505_CLASS/associated
!panel: aliGasSys/AliGas_device_state.pnl
    state: READY	!color: FwStateOKPhysics
    state: NOT_READY	!color: FwStateOKNotPhysics
    state: ERROR	!color: FwStateAttention3

object: Gas_Gs_GSY0505:PMD_Gs_GSY0505 is_of_class PMD_DCS_GAS_PMD_GSAliGas_Gs_GSY0505_CLASS

objectset: PMD_DCS_GAS_PMD_GSALIGAS_GS_GSY0505_FWSETSTATES {Gas_Gs_GSY0505:PMD_Gs_GSY0505 }
objectset: PMD_DCS_GAS_PMD_GSALIGAS_GS_GSY0505_FWSETACTIONS {Gas_Gs_GSY0505:PMD_Gs_GSY0505 }


objectset: PMD_DCS_GAS_PMD_GSFWCHILDREN_FWSETACTIONS union {PMD_DCS_GAS_PMD_GSALIGAS_GS_GSSTEPWS_FWSETACTIONS,
	PMD_DCS_GAS_PMD_GSALIGAS_GS_GSY0505_FWSETACTIONS }
objectset: PMD_DCS_GAS_PMD_GSFWCHILDREN_FWSETSTATES union {PMD_DCS_GAS_PMD_GSALIGAS_GS_GSSTEPWS_FWSETSTATES,
	PMD_DCS_GAS_PMD_GSALIGAS_GS_GSY0505_FWSETSTATES }

class: PMD_DCS_GAS_PMD_MXTOP_dcs_gas_subsys_OT_CLASS
!panel: aliGasSys/aliGas_detectorGasElements_visualize.pnl
    state: NOT_READY	!color: FwStateOKNotPhysics
        when ( any_in PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETSTATES in_state ERROR ) move_to ERROR
        when ( all_in PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETSTATES in_state READY ) move_to READY
    state: READY	!color: FwStateOKPhysics
        when ( any_in PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETSTATES in_state ERROR ) move_to ERROR
        when ( any_in PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETSTATES in_state NOT_READY ) move_to NOT_READY
    state: ERROR	!color: FwStateAttention3
        when ( all_in PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETSTATES not_in_state ERROR ) move_to NOT_READY
    state: NO_CONNECTION	!color: FwStateAttention2
        when ( all_in PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETSTATES in_state READY )  move_to READY
        when ( any_in PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETSTATES not_in_state READY )  move_to NOT_READY

object: PMD_DCS_GAS_PMD_MX is_of_class PMD_DCS_GAS_PMD_MXTOP_dcs_gas_subsys_OT_CLASS

class: PMD_DCS_GAS_PMD_MXAliGas_Mx_StepperWS_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETSTATES
            remove &VAL_OF_Device from PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETSTATES
            insert &VAL_OF_Device in PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETACTIONS
            move_to READY

object: PMD_DCS_GAS_PMD_MXAliGas_Mx_StepperWS_FWDM is_of_class PMD_DCS_GAS_PMD_MXAliGas_Mx_StepperWS_FwDevMode_CLASS


class: PMD_DCS_GAS_PMD_MXAliGas_Mx_StepperWS_CLASS/associated
!panel: aliGasSys/AliGas_device_state.pnl
    state: READY	!color: FwStateOKPhysics
    state: NOT_READY	!color: FwStateOKNotPhysics
    state: ERROR	!color: FwStateAttention3

object: Gas_Mx_StepperWS:PMD_Mx_StepperWS is_of_class PMD_DCS_GAS_PMD_MXAliGas_Mx_StepperWS_CLASS

objectset: PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETSTATES {Gas_Mx_StepperWS:PMD_Mx_StepperWS }
objectset: PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETACTIONS {Gas_Mx_StepperWS:PMD_Mx_StepperWS }


objectset: PMD_DCS_GAS_PMD_MXFWCHILDREN_FWSETACTIONS union {PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETACTIONS }
objectset: PMD_DCS_GAS_PMD_MXFWCHILDREN_FWSETSTATES union {PMD_DCS_GAS_PMD_MXALIGAS_MX_STEPPERWS_FWSETSTATES }

class: PMD_DCS_GAS_PMD_PLTOP_dcs_gas_subsys_OT_CLASS
!panel: aliGasSys/aliGas_detectorGasElements_visualize.pnl
    state: NOT_READY	!color: FwStateOKNotPhysics
        when ( any_in PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES in_state ERROR ) move_to ERROR
        when ( all_in PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES in_state READY ) move_to READY
        when ( any_in PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES in_state NOT_READY )  move_to NO_CONNECTION
    state: READY	!color: FwStateOKPhysics
        when ( any_in PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES in_state ERROR ) move_to ERROR
        when ( any_in PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES in_state NOT_READY )  move_to NO_CONNECTION
        when ( any_in PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES in_state NOT_READY ) move_to NOT_READY
    state: ERROR	!color: FwStateAttention3
        when ( all_in PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES not_in_state ERROR ) move_to NOT_READY
    state: NO_CONNECTION	!color: FwStateAttention2
        when ( any_in PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES in_state NOT_READY )  stay_in_state
        when ( all_in PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES in_state READY )  move_to READY
        when ( any_in PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES not_in_state READY )  move_to NOT_READY

object: PMD_DCS_GAS_PMD_PL is_of_class PMD_DCS_GAS_PMD_PLTOP_dcs_gas_subsys_OT_CLASS

class: PMD_DCS_GAS_PMD_PLAliGas_PlcCounter_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES
            remove &VAL_OF_Device from PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES
            insert &VAL_OF_Device in PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETACTIONS
            move_to READY

object: PMD_DCS_GAS_PMD_PLAliGas_PlcCounter_FWDM is_of_class PMD_DCS_GAS_PMD_PLAliGas_PlcCounter_FwDevMode_CLASS


class: PMD_DCS_GAS_PMD_PLAliGas_PlcCounter_CLASS/associated
!panel: aliGasSys/AliGas_device_state.pnl
    state: READY	!color: FwStateOKPhysics
    state: NOT_READY	!color: FwStateOKNotPhysics
    state: ERROR	!color: FwStateAttention3

object: Gas_PlcCounter:PMD_PlcCounter is_of_class PMD_DCS_GAS_PMD_PLAliGas_PlcCounter_CLASS

objectset: PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES {Gas_PlcCounter:PMD_PlcCounter }
objectset: PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETACTIONS {Gas_PlcCounter:PMD_PlcCounter }


objectset: PMD_DCS_GAS_PMD_PLFWCHILDREN_FWSETACTIONS union {PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETACTIONS }
objectset: PMD_DCS_GAS_PMD_PLFWCHILDREN_FWSETSTATES union {PMD_DCS_GAS_PMD_PLALIGAS_PLCCOUNTER_FWSETSTATES }

class: PMD_DCS_GAS_PMDTOP_dcs_gas_det_OT_CLASS
!panel: aliGasSys/aliGas_detectorGasElements_visualize.pnl
    state: NOT_READY	!color: FwStateOKNotPhysics
        when ( any_in PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES in_state ERROR ) move_to ERROR
        when ( any_in PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES in_state NO_CONNECTION )  move_to NO_CONNECTION
        when ( all_in PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES in_state READY ) move_to READY
    state: READY	!color: FwStateOKPhysics
        when ( any_in PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES in_state ERROR ) move_to ERROR
        when ( any_in PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES in_state NO_CONNECTION )  move_to NO_CONNECTION
        when ( any_in PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES in_state NOT_READY ) move_to NOT_READY
    state: ERROR	!color: FwStateAttention3
        when ( all_in PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES not_in_state ERROR ) move_to NOT_READY
    state: NO_CONNECTION	!color: FwStateAttention2
        when ( any_in PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES in_state NO_CONNECTION )  stay_in_state
        when ( all_in PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES in_state READY )  move_to READY
        when ( any_in PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES not_in_state READY )  move_to NOT_READY

object: PMD_DCS_GAS_PMD is_of_class PMD_DCS_GAS_PMDTOP_dcs_gas_det_OT_CLASS

class: PMD_DCS_GAS_PMDdcs_gas_subsys_OT_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES
            remove &VAL_OF_Device from PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES
            insert &VAL_OF_Device in PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETACTIONS
            move_to READY

object: PMD_DCS_GAS_PMDdcs_gas_subsys_OT_FWDM is_of_class PMD_DCS_GAS_PMDdcs_gas_subsys_OT_FwDevMode_CLASS


objectset: PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES {PMD_DCS_GAS_PMD_DI,
	PMD_DCS_GAS_PMD_GS,
	PMD_DCS_GAS_PMD_MX,
	PMD_DCS_GAS_PMD_PL }
objectset: PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETACTIONS {PMD_DCS_GAS_PMD_DI,
	PMD_DCS_GAS_PMD_GS,
	PMD_DCS_GAS_PMD_MX,
	PMD_DCS_GAS_PMD_PL }


objectset: PMD_DCS_GAS_PMDFWCHILDREN_FWSETACTIONS union {PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETACTIONS }
objectset: PMD_DCS_GAS_PMDFWCHILDREN_FWSETSTATES union {PMD_DCS_GAS_PMDDCS_GAS_SUBSYS_OT_FWSETSTATES }

class: PMD_AUXTOP_powernode_CLASS
!panel: powernode.pnl
    state: OFF	!color: _3DFace
        when (  ( all_in PMD_AUXFWCAENCHANNELLVNEW_FWSETSTATES in_state ON ) and
       ( all_in PMD_AUXFWCAENCRATESY1527_FWSETSTATES in_state READY )  )  move_to READY
        action: GO_STANDBY	!visible: 1
            do GO_ON all_in PMD_AUXFWCAENCHANNELLVNEW_FWSETACTIONS
            move_to READY
    state: READY	!color: FwStateOKPhysics
        when ( any_in PMD_AUXFWCHILDREN_FWSETSTATES in_state ERROR )  move_to ERROR
        when ( any_in PMD_AUXFWCAENCRATESY1527_FWSETSTATES not_in_state READY )  move_to ERROR
        
        when (  ( any_in PMD_AUXFWCAENCHANNELLVNEW_FWSETSTATES in_state OFF ) or
       ( all_in PMD_AUXFWCAENCHANNELLVNEW_FWSETSTATES in_state TRIPPED )  )  move_to ERROR
        when ( all_in PMD_AUXFWCAENCHANNELLVNEW_FWSETSTATES in_state OFF )  move_to OFF
        action: GO_OFF	!visible: 1
            do GO_OFF all_in PMD_AUXFWCAENCHANNELLVNEW_FWSETACTIONS
            if ( any_in PMD_AUXFWCAENCHANNELLVNEW_FWSETSTATES not_in_state OFF )  then
            move_to READY
            endif
            move_to OFF
        action: CONFIGURE	!visible: 1
            do GO_ON all_in PMD_AUXFWCAENCHANNELLVNEW_FWSETACTIONS
    state: ERROR	!color: FwStateAttention3
        when (  ( all_in PMD_AUXFWCAENCHANNELLVNEW_FWSETSTATES in_state ON ) and
       ( all_in PMD_AUXFWCAENCRATESY1527_FWSETSTATES in_state READY )  )  move_to READY
        action: RECOVER	!visible: 1
            do REPAIR all_in PMD_AUXFWCAENCHANNELLVNEW_FWSETACTIONS
            
            if (  ( any_in PMD_AUXFWCAENCHANNELLVNEW_FWSETSTATES in_state TRIPPED ) or
                   ( any_in PMD_AUXFWCAENCHANNELLVNEW_FWSETSTATES in_state OFF )  )  then
            move_to OFF
            endif
            move_to READY

object: PMD_AUX is_of_class PMD_AUXTOP_powernode_CLASS

class: PMD_AUXFwCaenCrateSY1527_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_AUXFWCAENCRATESY1527_FWSETSTATES
            remove &VAL_OF_Device from PMD_AUXFWCAENCRATESY1527_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_AUXFWCAENCRATESY1527_FWSETSTATES
            insert &VAL_OF_Device in PMD_AUXFWCAENCRATESY1527_FWSETACTIONS
            move_to READY

object: PMD_AUXFwCaenCrateSY1527_FWDM is_of_class PMD_AUXFwCaenCrateSY1527_FwDevMode_CLASS


class: PMD_AUXFwCaenCrateSY1527_CLASS/associated
!panel: FwCaenCrateSY1527.pnl
    state: READY	!color: FwStateOKPhysics
        action: KILL	!visible: 1
        action: CLEAR_ALARMS	!visible: 1
    state: DISCONNECTED	!color: FwStateAttention3
    state: ERROR	!color: FwStateAttention3

object: CAEN:CAENHVPS is_of_class PMD_AUXFwCaenCrateSY1527_CLASS

objectset: PMD_AUXFWCAENCRATESY1527_FWSETSTATES {CAEN:CAENHVPS }
objectset: PMD_AUXFWCAENCRATESY1527_FWSETACTIONS {CAEN:CAENHVPS }

class: PMD_AUXFwCaenChannelLVnew_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_AUXFWCAENCHANNELLVNEW_FWSETSTATES
            remove &VAL_OF_Device from PMD_AUXFWCAENCHANNELLVNEW_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_AUXFWCAENCHANNELLVNEW_FWSETSTATES
            insert &VAL_OF_Device in PMD_AUXFWCAENCHANNELLVNEW_FWSETACTIONS
            move_to READY

object: PMD_AUXFwCaenChannelLVnew_FWDM is_of_class PMD_AUXFwCaenChannelLVnew_FwDevMode_CLASS


class: PMD_AUXFwCaenChannelLVnew_CLASS/associated
!panel: FwCaenChannel|FwCaenChannelLVnew.pnl
    state: ON	!color: FwStateOKPhysics
        action: GO_OFF	!visible: 1
    state: OFF	!color: FwStateOKNotPhysics
        action: GO_ON	!visible: 1
    state: TRIPPED	!color: FwStateAttention3
        action: REPAIR	!visible: 1
    state: ERROR	!color: FwStateAttention3
        action: REPAIR	!visible: 1

object: CAEN:CAENHVPS:branchController14:easyCrate4:powerConverter22:channel000 is_of_class PMD_AUXFwCaenChannelLVnew_CLASS

object: CAEN:CAENHVPS:branchController14:easyCrate4:powerConverter22:channel001 is_of_class PMD_AUXFwCaenChannelLVnew_CLASS

objectset: PMD_AUXFWCAENCHANNELLVNEW_FWSETSTATES {CAEN:CAENHVPS:branchController14:easyCrate4:powerConverter22:channel000,
	CAEN:CAENHVPS:branchController14:easyCrate4:powerConverter22:channel001 }
objectset: PMD_AUXFWCAENCHANNELLVNEW_FWSETACTIONS {CAEN:CAENHVPS:branchController14:easyCrate4:powerConverter22:channel000,
	CAEN:CAENHVPS:branchController14:easyCrate4:powerConverter22:channel001 }


objectset: PMD_AUXFWCHILDREN_FWSETACTIONS union {PMD_AUXFWCAENCRATESY1527_FWSETACTIONS,
	PMD_AUXFWCAENCHANNELLVNEW_FWSETACTIONS }
objectset: PMD_AUXFWCHILDREN_FWSETSTATES union {PMD_AUXFWCAENCRATESY1527_FWSETSTATES,
	PMD_AUXFWCAENCHANNELLVNEW_FWSETSTATES }

class: PMD_CROCUSTOP_pmd_crocus_pwr_CLASS
!panel: pmd_crocus_pwr.pnl
    state: ERROR	!color: FwStateAttention3
        when (  ( any_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES in_state TRIPPED ) or
       ( any_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES in_state ERROR )  )  stay_in_state
        when ( all_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES in_state OFF )  move_to OFF
        when ( all_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES in_state ON )  move_to READY
        action: RECOVER	!visible: 1
            do REPAIR all_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETACTIONS
            if ( all_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES not_in_state ON )  then
            move_to ERROR
            endif
            move_to OFF
    state: READY	!color: FwStateOKPhysics
        when ( all_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES in_state OFF )  move_to OFF
        when (  ( any_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES in_state TRIPPED ) or
       ( any_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES in_state ERROR )  )  move_to ERROR
        action: GO_OFF	!visible: 1
            do GO_OFF all_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETACTIONS
            if ( any_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES not_in_state OFF )  then
            move_to READY
            endif
            move_to OFF
    state: OFF	!color: FwStateOKNotPhysics
        when ( all_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES in_state ON )  move_to READY
        when (  ( any_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES in_state TRIPPED ) or
       ( any_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES in_state ERROR )  )  move_to ERROR
        action: CONFIGURE	!visible: 1
            do GO_ON all_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETACTIONS
            if ( any_in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES not_in_state ON )  then
            move_to OFF
            endif
            move_to READY

object: PMD_CROCUS is_of_class PMD_CROCUSTOP_pmd_crocus_pwr_CLASS

class: PMD_CROCUSFwCaenChannelCrocus_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES
            remove &VAL_OF_Device from PMD_CROCUSFWCAENCHANNELCROCUS_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES
            insert &VAL_OF_Device in PMD_CROCUSFWCAENCHANNELCROCUS_FWSETACTIONS
            move_to READY

object: PMD_CROCUSFwCaenChannelCrocus_FWDM is_of_class PMD_CROCUSFwCaenChannelCrocus_FwDevMode_CLASS


class: PMD_CROCUSFwCaenChannelCrocus_CLASS/associated
!panel: FwCaenChannel|FwCaenChannelCrocus.pnl
    state: ON	!color: FwStateOKPhysics
        action: GO_OFF	!visible: 1
    state: OFF	!color: FwStateOKNotPhysics
        action: GO_ON	!visible: 1
    state: ERROR	!color: FwStateAttention3
        action: RECOVER	!visible: 1

object: CAEN:CAENHVPS:branchController14:easyCrate4:easyBoard03:channel000 is_of_class PMD_CROCUSFwCaenChannelCrocus_CLASS

object: CAEN:CAENHVPS:branchController14:easyCrate4:easyBoard03:channel001 is_of_class PMD_CROCUSFwCaenChannelCrocus_CLASS

object: CAEN:CAENHVPS:branchController14:easyCrate4:easyBoard14:channel000 is_of_class PMD_CROCUSFwCaenChannelCrocus_CLASS

object: CAEN:CAENHVPS:branchController14:easyCrate4:easyBoard14:channel001 is_of_class PMD_CROCUSFwCaenChannelCrocus_CLASS

objectset: PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES {CAEN:CAENHVPS:branchController14:easyCrate4:easyBoard03:channel000,
	CAEN:CAENHVPS:branchController14:easyCrate4:easyBoard03:channel001,
	CAEN:CAENHVPS:branchController14:easyCrate4:easyBoard14:channel000,
	CAEN:CAENHVPS:branchController14:easyCrate4:easyBoard14:channel001 }
objectset: PMD_CROCUSFWCAENCHANNELCROCUS_FWSETACTIONS {CAEN:CAENHVPS:branchController14:easyCrate4:easyBoard03:channel000,
	CAEN:CAENHVPS:branchController14:easyCrate4:easyBoard03:channel001,
	CAEN:CAENHVPS:branchController14:easyCrate4:easyBoard14:channel000,
	CAEN:CAENHVPS:branchController14:easyCrate4:easyBoard14:channel001 }


objectset: PMD_CROCUSFWCHILDREN_FWSETACTIONS union {PMD_CROCUSFWCAENCHANNELCROCUS_FWSETACTIONS }
objectset: PMD_CROCUSFWCHILDREN_FWSETSTATES union {PMD_CROCUSFWCAENCHANNELCROCUS_FWSETSTATES }

class: powernode_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from POWERNODE_FWSETSTATES
            remove &VAL_OF_Device from POWERNODE_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in POWERNODE_FWSETSTATES
            insert &VAL_OF_Device in POWERNODE_FWSETACTIONS
            move_to READY

object: powernode_FWDM is_of_class powernode_FwDevMode_CLASS


objectset: POWERNODE_FWSETSTATES {PMD_AUX }
objectset: POWERNODE_FWSETACTIONS {PMD_AUX }

class: pmd_crocus_pwr_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from PMD_CROCUS_PWR_FWSETSTATES
            remove &VAL_OF_Device from PMD_CROCUS_PWR_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in PMD_CROCUS_PWR_FWSETSTATES
            insert &VAL_OF_Device in PMD_CROCUS_PWR_FWSETACTIONS
            move_to READY

object: pmd_crocus_pwr_FWDM is_of_class pmd_crocus_pwr_FwDevMode_CLASS


objectset: PMD_CROCUS_PWR_FWSETSTATES {PMD_CROCUS }
objectset: PMD_CROCUS_PWR_FWSETACTIONS {PMD_CROCUS }

class: dcs_gas_det_OT_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from DCS_GAS_DET_OT_FWSETSTATES
            remove &VAL_OF_Device from DCS_GAS_DET_OT_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in DCS_GAS_DET_OT_FWSETSTATES
            insert &VAL_OF_Device in DCS_GAS_DET_OT_FWSETACTIONS
            move_to READY

object: dcs_gas_det_OT_FWDM is_of_class dcs_gas_det_OT_FwDevMode_CLASS


objectset: DCS_GAS_DET_OT_FWSETSTATES {PMD_DCS_GAS_PMD }
objectset: DCS_GAS_DET_OT_FWSETACTIONS {PMD_DCS_GAS_PMD }

class: TOP_infranodenew_CLASS
!panel: infranodenew.pnl
    state: OFF	!color: FwStateOKNotPhysics
        when ( all_in FWCHILDREN_FWSETSTATES in_state READY )  move_to READY
        
        when ( all_in FWCHILDREN_FWSETSTATES not_in_state READY ) stay_in_state
        action: GO_STANDBY	!visible: 1
            do GO_STANDBY all_in POWERNODE_FWSETACTIONS
            if ( all_in FWCHILDREN_FWSETSTATES not_in_state READY )  then
            move_to OFF
            endif
            move_to READY
        action: GO_READY	!visible: 1
            do CONFIGURE all_in PMD_CROCUS_PWR_FWSETACTIONS
            move_to READY
    state: READY	!color: FwStateOKPhysics
        when ( any_in FWCHILDREN_FWSETSTATES in_state ERROR )  move_to ERROR
        when ( any_in FWCHILDREN_FWSETSTATES in_state OFF )  move_to OFF
        when (  ( any_in VME_FWSETSTATES in_state NOT_READY ) or
       ( all_in VME_FWSETSTATES in_state ERROR )  )  move_to ERROR
        when (  ( any_in DCS_GAS_DET_OT_FWSETSTATES in_state NOT_READY ) or
       ( all_in DCS_GAS_DET_OT_FWSETSTATES in_state ERROR )  )  move_to ERROR
        action: GO_OFF	!visible: 1
            do GO_OFF all_in PMD_CROCUS_PWR_FWSETACTIONS
            move_to OFF
        action: CONFIGURE	!visible: 1
            do CONFIGURE all_in POWERNODE_FWSETACTIONS
    state: ERROR	!color: FwStateAttention3
        when ( all_in FWCHILDREN_FWSETSTATES in_state READY )  move_to READY
        when ( all_in FWCHILDREN_FWSETSTATES not_in_state READY )  move_to OFF
        action: RECOVER	!visible: 1
            do RECOVER all_in POWERNODE_FWSETACTIONS
            move_to OFF

object: PMD_INFRA is_of_class TOP_infranodenew_CLASS

class: FwChildrenMode_CLASS
!panel: FwChildrenMode.pnl
    state: Complete	!color: _3DFace
        when ( any_in FWDEVMODE_FWSETSTATES in_state DISABLED )  move_to IncompleteDev
    state: Incomplete	!color: FwStateAttention2
    state: IncompleteDev	!color: FwStateAttention1
        when (  ( all_in FWDEVMODE_FWSETSTATES not_in_state DISABLED )  ) move_to Complete
    state: IncompleteDead	!color: FwStateAttention3

object: PMD_INFRA_FWCNM is_of_class FwChildrenMode_CLASS

class: FwMode_CLASS
!panel: FwMode.pnl
    state: Excluded	!color: FwStateOKNotPhysics
        action: Take(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 1
            move_to InLocal
        action: Include(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
            move_to Included
        action: Manual	!visible: 0
            move_to Manual
        action: Ignore	!visible: 0
            move_to Ignored
    state: Included	!color: FwStateOKPhysics
        action: Exclude(string OWNER = "")	!visible: 0
            move_to Excluded
        action: Manual(string OWNER = "")	!visible: 0
            move_to Manual
        action: Ignore(string OWNER = "")	!visible: 0
            move_to Ignored
        action: ExcludeAll(string OWNER = "")	!visible: 0
            move_to Excluded
        action: Include(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
            move_to Included
        action: Free(string OWNER = "")	!visible: 0
            move_to Included
        action: SetMode(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
    state: InLocal	!color: FwStateOKNotPhysics
        action: Release(string OWNER = "")	!visible: 1
            move_to Excluded
        action: ReleaseAll(string OWNER = "")	!visible: 1
            move_to Excluded
        action: SetMode(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
        action: Take(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 1
            move_to InLocal
    state: Manual	!color: FwStateOKNotPhysics
        action: Include(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
            move_to Included
        action: Take(string OWNER = "")	!visible: 1
            move_to InManual
        action: Exclude(string OWNER = "")	!visible: 0
            move_to Excluded
        action: Ignore	!visible: 0
            move_to Ignored
        action: Free(string OWNER = "")	!visible: 0
            move_to Excluded
        action: ExcludeAll(string OWNER = "")	!visible: 0
            move_to Excluded
    state: InManual	!color: FwStateOKNotPhysics
        action: Release(string OWNER = "")	!visible: 1
            move_to Manual
        action: SetMode(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
        action: ReleaseAll(string OWNER = "")	!visible: 0
            move_to Excluded
        action: SetInLocal	!visible: 0
            move_to InLocal
    state: Ignored	!color: FwStateOKNotPhysics
        action: Include	!visible: 0
            move_to Included
        action: Exclude(string OWNER = "")	!visible: 0
            move_to Excluded
        action: Manual	!visible: 0
            move_to Manual
        action: SetMode(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
        action: Free(string OWNER = "")	!visible: 0
            move_to Included
        action: ExcludeAll(string OWNER = "")	!visible: 0
            move_to Excluded

object: PMD_INFRA_FWM is_of_class FwMode_CLASS

class: VME_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from VME_FWSETSTATES
            remove &VAL_OF_Device from VME_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in VME_FWSETSTATES
            insert &VAL_OF_Device in VME_FWSETACTIONS
            move_to READY

object: VME_FWDM is_of_class VME_FwDevMode_CLASS


objectset: VME_FWSETSTATES {PMD_VME }
objectset: VME_FWSETACTIONS {PMD_VME }

class: FwDevMode_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from FWDEVMODE_FWSETSTATES
            remove &VAL_OF_Device from FWDEVMODE_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in FWDEVMODE_FWSETSTATES
            insert &VAL_OF_Device in FWDEVMODE_FWSETACTIONS
            move_to READY

object: FwDevMode_FWDM is_of_class FwDevMode_FwDevMode_CLASS


class: FwDevMode_CLASS/associated
!panel: FwDevMode.pnl
    state: ENABLED	!color: FwStateOKPhysics
    state: DISABLED	!color: FwStateAttention1

object: PMD_INFRA:PMD_AUX_FWDM is_of_class FwDevMode_CLASS

object: PMD_INFRA:PMD_CROCUS_FWDM is_of_class FwDevMode_CLASS

object: PMD_INFRA:PMD_DCS_GAS_PMD_DI_FWDM is_of_class FwDevMode_CLASS

object: PMD_INFRA:PMD_DCS_GAS_PMD_FWDM is_of_class FwDevMode_CLASS

object: PMD_INFRA:PMD_DCS_GAS_PMD_GS_FWDM is_of_class FwDevMode_CLASS

object: PMD_INFRA:PMD_DCS_GAS_PMD_MX_FWDM is_of_class FwDevMode_CLASS

object: PMD_INFRA:PMD_DCS_GAS_PMD_PL_FWDM is_of_class FwDevMode_CLASS

object: PMD_INFRA:PMD_VME_FWDM is_of_class FwDevMode_CLASS

object: PMD_INFRA_FWDM is_of_class FwDevMode_CLASS

objectset: FWDEVMODE_FWSETSTATES {PMD_INFRA:PMD_AUX_FWDM,
	PMD_INFRA:PMD_CROCUS_FWDM,
	PMD_INFRA:PMD_DCS_GAS_PMD_DI_FWDM,
	PMD_INFRA:PMD_DCS_GAS_PMD_FWDM,
	PMD_INFRA:PMD_DCS_GAS_PMD_GS_FWDM,
	PMD_INFRA:PMD_DCS_GAS_PMD_MX_FWDM,
	PMD_INFRA:PMD_DCS_GAS_PMD_PL_FWDM,
	PMD_INFRA:PMD_VME_FWDM,
	PMD_INFRA_FWDM }
objectset: FWDEVMODE_FWSETACTIONS {PMD_INFRA:PMD_AUX_FWDM,
	PMD_INFRA:PMD_CROCUS_FWDM,
	PMD_INFRA:PMD_DCS_GAS_PMD_DI_FWDM,
	PMD_INFRA:PMD_DCS_GAS_PMD_FWDM,
	PMD_INFRA:PMD_DCS_GAS_PMD_GS_FWDM,
	PMD_INFRA:PMD_DCS_GAS_PMD_MX_FWDM,
	PMD_INFRA:PMD_DCS_GAS_PMD_PL_FWDM,
	PMD_INFRA:PMD_VME_FWDM,
	PMD_INFRA_FWDM }


objectset: FWCHILDREN_FWSETACTIONS union {POWERNODE_FWSETACTIONS,
	PMD_CROCUS_PWR_FWSETACTIONS,
	DCS_GAS_DET_OT_FWSETACTIONS,
	VME_FWSETACTIONS }
objectset: FWCHILDREN_FWSETSTATES union {POWERNODE_FWSETSTATES,
	PMD_CROCUS_PWR_FWSETSTATES,
	DCS_GAS_DET_OT_FWSETSTATES,
	VME_FWSETSTATES }

