class: TOP_SDD_CONFIGURATOR_CLASS
!panel: SDD_CONFIGURATOR.pnl
    state: DOWNLOADING	!color: FwStateAttention1
        when ( any_in FWSDDCONFIGURATOR_FWSETSTATES in_state NOT_CONFIGURED )  move_to NOT_CONFIGURED
        when ( any_in FWSDDCONFIGURATOR_FWSETSTATES in_state CONFIGURED )  move_to CONFIGURED
    state: CONFIGURED	!color: FwStateOKNotPhysics
        when ( any_in FWSDDCONFIGURATOR_FWSETSTATES in_state NOT_CONFIGURED )  move_to NOT_CONFIGURED
        when ( any_in FWSDDCONFIGURATOR_FWSETSTATES in_state DOWNLOADING )  move_to DOWNLOADING
        action: CONFIGURE(string run_type = "")	!visible: 1
            do CONFIGURE(run_type = run_type) all_in FWSDDCONFIGURATOR_FWSETACTIONS
    state: NOT_CONFIGURED	!color: FwStateAttention2
        when ( any_in FWSDDCONFIGURATOR_FWSETSTATES in_state CONFIGURED )  move_to CONFIGURED
        when ( any_in FWSDDCONFIGURATOR_FWSETSTATES in_state DOWNLOADING )  move_to DOWNLOADING
        action: CONFIGURE(string run_type = "")	!visible: 1
            do CONFIGURE(run_type = run_type) all_in FWSDDCONFIGURATOR_FWSETACTIONS

object: SDD_CONFIGURATOR is_of_class TOP_SDD_CONFIGURATOR_CLASS

class: FwChildrenMode_CLASS
!panel: FwChildrenMode.pnl
    state: Complete	!color: _3DFace
        when ( any_in FWDEVMODE_FWSETSTATES in_state DISABLED )  move_to IncompleteDev
    state: Incomplete	!color: FwStateAttention2
    state: IncompleteDev	!color: FwStateAttention1
        when (  ( all_in FWDEVMODE_FWSETSTATES not_in_state DISABLED )  ) move_to Complete
    state: IncompleteDead	!color: FwStateAttention3

object: SDD_CONFIGURATOR_FWCNM is_of_class FwChildrenMode_CLASS

class: FwMode_CLASS
!panel: FwMode.pnl
    state: Excluded	!color: FwStateOKNotPhysics
        action: Take(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 1
            move_to InLocal
        action: Include(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
            move_to Included
        action: Manual	!visible: 0
            move_to Manual
        action: Ignore	!visible: 0
            move_to Ignored
    state: Included	!color: FwStateOKPhysics
        action: Exclude(string OWNER = "")	!visible: 0
            move_to Excluded
        action: Manual(string OWNER = "")	!visible: 0
            move_to Manual
        action: Ignore(string OWNER = "")	!visible: 0
            move_to Ignored
        action: ExcludeAll(string OWNER = "")	!visible: 0
            move_to Excluded
        action: Include(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
            move_to Included
        action: Free(string OWNER = "")	!visible: 0
            move_to Included
        action: SetMode(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
    state: InLocal	!color: FwStateOKNotPhysics
        action: Release(string OWNER = "")	!visible: 1
            move_to Excluded
        action: ReleaseAll(string OWNER = "")	!visible: 1
            move_to Excluded
        action: SetMode(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
        action: Take(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 1
            move_to InLocal
    state: Manual	!color: FwStateOKNotPhysics
        action: Include(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
            move_to Included
        action: Take(string OWNER = "")	!visible: 1
            move_to InManual
        action: Exclude(string OWNER = "")	!visible: 0
            move_to Excluded
        action: Ignore	!visible: 0
            move_to Ignored
        action: Free(string OWNER = "")	!visible: 0
            move_to Excluded
        action: ExcludeAll(string OWNER = "")	!visible: 0
            move_to Excluded
    state: InManual	!color: FwStateOKNotPhysics
        action: Release(string OWNER = "")	!visible: 1
            move_to Manual
        action: SetMode(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
        action: ReleaseAll(string OWNER = "")	!visible: 0
            move_to Excluded
        action: SetInLocal	!visible: 0
            move_to InLocal
    state: Ignored	!color: FwStateOKNotPhysics
        action: Include	!visible: 0
            move_to Included
        action: Exclude(string OWNER = "")	!visible: 0
            move_to Excluded
        action: Manual	!visible: 0
            move_to Manual
        action: SetMode(string OWNER = "",string EXCLUSIVE = "YES")	!visible: 0
        action: Free(string OWNER = "")	!visible: 0
            move_to Included
        action: ExcludeAll(string OWNER = "")	!visible: 0
            move_to Excluded

object: SDD_CONFIGURATOR_FWM is_of_class FwMode_CLASS

class: FwDevMode_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from FWDEVMODE_FWSETSTATES
            remove &VAL_OF_Device from FWDEVMODE_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in FWDEVMODE_FWSETSTATES
            insert &VAL_OF_Device in FWDEVMODE_FWSETACTIONS
            move_to READY

object: FwDevMode_FWDM is_of_class FwDevMode_FwDevMode_CLASS


class: FwDevMode_CLASS/associated
!panel: FwDevMode.pnl
    state: ENABLED	!color: FwStateOKPhysics
    state: DISABLED	!color: FwStateAttention1

object: SDD_CONFIGURATOR_FWDM is_of_class FwDevMode_CLASS

objectset: FWDEVMODE_FWSETSTATES is_of_class VOID {SDD_CONFIGURATOR_FWDM }
objectset: FWDEVMODE_FWSETACTIONS is_of_class VOID {SDD_CONFIGURATOR_FWDM }

class: FwSddConfigurator_FwDevMode_CLASS
    state: READY
        action: Disable(Device)
            remove &VAL_OF_Device from FWSDDCONFIGURATOR_FWSETSTATES
            remove &VAL_OF_Device from FWSDDCONFIGURATOR_FWSETACTIONS
            move_to READY
        action: Enable(Device)
            insert &VAL_OF_Device in FWSDDCONFIGURATOR_FWSETSTATES
            insert &VAL_OF_Device in FWSDDCONFIGURATOR_FWSETACTIONS
            move_to READY

object: FwSddConfigurator_FWDM is_of_class FwSddConfigurator_FwDevMode_CLASS


class: FwSddConfigurator_CLASS/associated
!panel: FwSddConfigurator.pnl
    state: NOT_CONFIGURED	!color: FwStateAttention2
        action: CONFIGURE(string run_type = "")	!visible: 1
    state: CONFIGURED	!color: FwStateOKNotPhysics
        action: CONFIGURE(string run_type = "")	!visible: 1
    state: DOWNLOADING	!color: FwStateAttention1

object: SddConfig:SddDefaultConfigurator is_of_class FwSddConfigurator_CLASS

objectset: FWSDDCONFIGURATOR_FWSETSTATES is_of_class VOID {SddConfig:SddDefaultConfigurator }
objectset: FWSDDCONFIGURATOR_FWSETACTIONS is_of_class VOID {SddConfig:SddDefaultConfigurator }


objectset: FWCHILDREN_FWSETACTIONS union {FWSDDCONFIGURATOR_FWSETACTIONS } is_of_class VOID
objectset: FWCHILDREN_FWSETSTATES union {FWSDDCONFIGURATOR_FWSETSTATES } is_of_class VOID

